/*     */ package org.hibernate.cfg;
/*     */ 
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import javax.persistence.JoinColumn;
/*     */ import javax.persistence.PrimaryKeyJoinColumn;
/*     */ import org.hibernate.AnnotationException;
/*     */ import org.hibernate.MappingException;
/*     */ import org.hibernate.annotations.common.util.StringHelper;
/*     */ import org.hibernate.mapping.Column;
/*     */ import org.hibernate.mapping.Join;
/*     */ import org.hibernate.mapping.KeyValue;
/*     */ import org.hibernate.mapping.PersistentClass;
/*     */ import org.hibernate.mapping.SimpleValue;
/*     */ import org.hibernate.mapping.Table;
/*     */ import org.hibernate.mapping.Value;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Ejb3JoinColumn
/*     */   extends Ejb3Column
/*     */ {
/*     */   private String referencedColumn;
/*     */   private String mappedBy;
/*     */   private String mappedByPropertyName;
/*     */   private String mappedByTableName;
/*     */   private String mappedByEntityName;
/*     */   private String manyToManyOwnerSideEntityName;
/*     */   public static final int NO_REFERENCE = 0;
/*     */   public static final int PK_REFERENCE = 1;
/*     */   public static final int NON_PK_REFERENCE = 2;
/*     */   
/*     */   public String getManyToManyOwnerSideEntityName()
/*     */   {
/*  41 */     return this.manyToManyOwnerSideEntityName;
/*     */   }
/*     */   
/*     */   public void setManyToManyOwnerSideEntityName(String manyToManyOwnerSideEntityName) {
/*  45 */     this.manyToManyOwnerSideEntityName = manyToManyOwnerSideEntityName;
/*     */   }
/*     */   
/*     */ 
/*     */   public void setReferencedColumn(String referencedColumn)
/*     */   {
/*  51 */     this.referencedColumn = referencedColumn;
/*     */   }
/*     */   
/*     */   public String getMappedBy() {
/*  55 */     return this.mappedBy;
/*     */   }
/*     */   
/*     */   public void setMappedBy(String mappedBy) {
/*  59 */     this.mappedBy = mappedBy;
/*     */   }
/*     */   
/*     */   private Ejb3JoinColumn()
/*     */   {
/*  64 */     setMappedBy("");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Ejb3JoinColumn(String sqlType, String name, boolean nullable, boolean unique, boolean insertable, boolean updatable, String referencedColumn, String secondaryTable, Map<String, Join> joins, PropertyHolder propertyHolder, String propertyName, String mappedBy, boolean isImplicit, ExtendedMappings mappings)
/*     */   {
/*  86 */     setImplicit(isImplicit);
/*  87 */     setSqlType(sqlType);
/*  88 */     setLogicalColumnName(name);
/*  89 */     setNullable(nullable);
/*  90 */     setUnique(unique);
/*  91 */     setInsertable(insertable);
/*  92 */     setUpdatable(updatable);
/*  93 */     setSecondaryTableName(secondaryTable);
/*  94 */     setPropertyHolder(propertyHolder);
/*  95 */     setJoins(joins);
/*  96 */     setMappings(mappings);
/*  97 */     setPropertyName(BinderHelper.getRelativePath(propertyHolder, propertyName));
/*  98 */     bind();
/*  99 */     this.referencedColumn = referencedColumn;
/* 100 */     this.mappedBy = mappedBy;
/*     */   }
/*     */   
/*     */   public String getReferencedColumn() {
/* 104 */     return this.referencedColumn;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Ejb3JoinColumn[] buildJoinColumns(JoinColumn[] anns, String mappedBy, Map<String, Join> joins, PropertyHolder propertyHolder, String propertyName, ExtendedMappings mappings)
/*     */   {
/* 114 */     JoinColumn[] actualColumns = propertyHolder.getOverriddenJoinColumn(StringHelper.qualify(propertyHolder.getPath(), propertyName));
/*     */     
/*     */ 
/* 117 */     if (actualColumns == null) actualColumns = anns;
/* 118 */     if ((actualColumns == null) || (actualColumns.length == 0)) {
/* 119 */       return new Ejb3JoinColumn[] { buildJoinColumn((JoinColumn)null, mappedBy, joins, propertyHolder, propertyName, mappings) };
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 124 */     int size = actualColumns.length;
/* 125 */     Ejb3JoinColumn[] result = new Ejb3JoinColumn[size];
/* 126 */     for (int index = 0; index < size; index++) {
/* 127 */       result[index] = buildJoinColumn(actualColumns[index], mappedBy, joins, propertyHolder, propertyName, mappings);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 136 */     return result;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static Ejb3JoinColumn buildJoinColumn(JoinColumn ann, String mappedBy, Map<String, Join> joins, PropertyHolder propertyHolder, String propertyName, ExtendedMappings mappings)
/*     */   {
/* 150 */     if (ann != null) {
/* 151 */       if (BinderHelper.isDefault(mappedBy)) {
/* 152 */         throw new AnnotationException("Illegal attempt to define a @JoinColumn with a mappedBy association: " + BinderHelper.getRelativePath(propertyHolder, propertyName));
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 157 */       Ejb3JoinColumn joinColumn = new Ejb3JoinColumn();
/* 158 */       joinColumn.setJoinAnnotation(ann, null);
/* 159 */       joinColumn.setJoins(joins);
/* 160 */       joinColumn.setPropertyHolder(propertyHolder);
/* 161 */       joinColumn.setPropertyName(BinderHelper.getRelativePath(propertyHolder, propertyName));
/* 162 */       joinColumn.setImplicit(false);
/* 163 */       joinColumn.setMappings(mappings);
/* 164 */       joinColumn.bind();
/* 165 */       return joinColumn;
/*     */     }
/*     */     
/* 168 */     Ejb3JoinColumn joinColumn = new Ejb3JoinColumn();
/* 169 */     joinColumn.setMappedBy(mappedBy);
/* 170 */     joinColumn.setJoins(joins);
/* 171 */     joinColumn.setPropertyHolder(propertyHolder);
/* 172 */     joinColumn.setPropertyName(BinderHelper.getRelativePath(propertyHolder, propertyName));
/* 173 */     joinColumn.setImplicit(true);
/* 174 */     joinColumn.setMappings(mappings);
/* 175 */     joinColumn.bind();
/* 176 */     return joinColumn;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void setJoinAnnotation(JoinColumn annJoin, String defaultName)
/*     */   {
/* 183 */     if (annJoin == null) {
/* 184 */       setImplicit(true);
/*     */     }
/*     */     else {
/* 187 */       setImplicit(false);
/* 188 */       if (!BinderHelper.isDefault(annJoin.columnDefinition())) setSqlType(annJoin.columnDefinition());
/* 189 */       if (!BinderHelper.isDefault(annJoin.name())) setLogicalColumnName(annJoin.name());
/* 190 */       setNullable(annJoin.nullable());
/* 191 */       setUnique(annJoin.unique());
/* 192 */       setInsertable(annJoin.insertable());
/* 193 */       setUpdatable(annJoin.updatable());
/* 194 */       setReferencedColumn(annJoin.referencedColumnName());
/* 195 */       setSecondaryTableName(annJoin.table());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Ejb3JoinColumn buildJoinColumn(PrimaryKeyJoinColumn pkJoinAnn, JoinColumn joinAnn, Value identifier, Map<String, Join> joins, PropertyHolder propertyHolder, ExtendedMappings mappings)
/*     */   {
/* 210 */     Column col = (Column)identifier.getColumnIterator().next();
/* 211 */     String defaultName = mappings.getLogicalColumnName(col.getName(), identifier.getTable());
/* 212 */     if ((pkJoinAnn != null) || (joinAnn != null)) { String referencedColumnName;
/*     */       String colName;
/*     */       String columnDefinition;
/*     */       String referencedColumnName;
/* 216 */       if (pkJoinAnn != null) {
/* 217 */         String colName = pkJoinAnn.name();
/* 218 */         String columnDefinition = pkJoinAnn.columnDefinition();
/* 219 */         referencedColumnName = pkJoinAnn.referencedColumnName();
/*     */       }
/*     */       else {
/* 222 */         colName = joinAnn.name();
/* 223 */         columnDefinition = joinAnn.columnDefinition();
/* 224 */         referencedColumnName = joinAnn.referencedColumnName();
/*     */       }
/* 226 */       String sqlType = "".equals(columnDefinition) ? null : columnDefinition;
/* 227 */       String name = "".equals(colName) ? defaultName : colName;
/* 228 */       return new Ejb3JoinColumn(sqlType, name, false, false, true, true, referencedColumnName, null, joins, propertyHolder, null, null, false, mappings);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 238 */     return new Ejb3JoinColumn((String)null, defaultName, false, false, true, true, null, (String)null, joins, propertyHolder, null, null, true, mappings);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setPersistentClass(PersistentClass persistentClass, Map<String, Join> joins)
/*     */   {
/* 252 */     this.propertyHolder = PropertyHolderBuilder.buildPropertyHolder(persistentClass, joins, getMappings());
/*     */   }
/*     */   
/*     */   public static void checkIfJoinColumn(Object columns, PropertyHolder holder, PropertyData property) {
/* 256 */     if (!(columns instanceof Ejb3JoinColumn[])) {
/* 257 */       throw new AnnotationException("@Column cannot be used on an association property: " + holder.getEntityName() + "." + property.getPropertyName());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void linkValueUsingDefaultColumnNaming(Column referencedColumn, PersistentClass referencedEntity, SimpleValue value)
/*     */   {
/* 270 */     String logicalReferencedColumn = getMappings().getLogicalColumnName(referencedColumn.getName(), referencedEntity.getTable());
/*     */     
/*     */ 
/* 273 */     boolean mappedBySide = (this.mappedByTableName != null) || (this.mappedByPropertyName != null);
/* 274 */     boolean ownerSide = getPropertyName() != null;
/*     */     
/* 276 */     Boolean isRefColumnQuoted = Boolean.valueOf(StringHelper.isQuoted(logicalReferencedColumn));
/* 277 */     String unquotedLogicalReferenceColumn = isRefColumnQuoted.booleanValue() ? StringHelper.unquote(logicalReferencedColumn) : logicalReferencedColumn;
/*     */     
/*     */     String columnName;
/*     */     
/* 281 */     if (mappedBySide) {
/* 282 */       String unquotedMappedbyTable = StringHelper.unquote(this.mappedByTableName);
/* 283 */       String columnName = getMappings().getNamingStrategy().foreignKeyColumnName(this.mappedByPropertyName, this.mappedByEntityName, unquotedMappedbyTable, unquotedLogicalReferenceColumn);
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 290 */       if ((isRefColumnQuoted.booleanValue()) || (StringHelper.isQuoted(this.mappedByTableName))) {
/* 291 */         columnName = StringHelper.quote(columnName);
/*     */       }
/*     */     }
/* 294 */     else if (ownerSide) {
/* 295 */       String logicalTableName = getMappings().getLogicalTableName(referencedEntity.getTable());
/* 296 */       String unquotedLogicalTableName = StringHelper.unquote(logicalTableName);
/* 297 */       String columnName = getMappings().getNamingStrategy().foreignKeyColumnName(getPropertyName(), referencedEntity.getEntityName(), unquotedLogicalTableName, unquotedLogicalReferenceColumn);
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 304 */       if ((isRefColumnQuoted.booleanValue()) || (StringHelper.isQuoted(logicalTableName))) {
/* 305 */         columnName = StringHelper.quote(columnName);
/*     */       }
/*     */     }
/*     */     else
/*     */     {
/* 310 */       String logicalTableName = getMappings().getLogicalTableName(referencedEntity.getTable());
/* 311 */       String unquotedLogicalTableName = StringHelper.unquote(logicalTableName);
/* 312 */       columnName = getMappings().getNamingStrategy().joinKeyColumnName(unquotedLogicalReferenceColumn, unquotedLogicalTableName);
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 317 */       if ((isRefColumnQuoted.booleanValue()) || (StringHelper.isQuoted(logicalTableName))) {
/* 318 */         columnName = StringHelper.quote(columnName);
/*     */       }
/*     */     }
/*     */     
/* 322 */     setLogicalColumnName(columnName);
/* 323 */     setReferencedColumn(logicalReferencedColumn);
/* 324 */     initMappingColumn(columnName, null, referencedColumn.getLength(), referencedColumn.getPrecision(), referencedColumn.getScale(), getMappingColumn().isNullable(), referencedColumn.getSqlType(), getMappingColumn().isUnique(), false);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 333 */     linkWithValue(value);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void linkValueUsingAColumnCopy(Column column, SimpleValue value)
/*     */   {
/* 340 */     initMappingColumn(column.getQuotedName(), null, column.getLength(), column.getPrecision(), column.getScale(), getMappingColumn().isNullable(), column.getSqlType(), getMappingColumn().isUnique(), false);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 351 */     linkWithValue(value);
/*     */   }
/*     */   
/*     */   protected void addColumnBinding(SimpleValue value) {
/* 355 */     if (StringHelper.isEmpty(this.mappedBy)) {
/* 356 */       String unquotedLogColName = StringHelper.unquote(getLogicalColumnName());
/* 357 */       String unquotedRefColumn = StringHelper.unquote(getReferencedColumn());
/* 358 */       String logicalColumnName = getMappings().getNamingStrategy().logicalCollectionColumnName(unquotedLogColName, getPropertyName(), unquotedRefColumn);
/*     */       
/* 360 */       if ((StringHelper.isQuoted(getLogicalColumnName())) || (StringHelper.isQuoted(getLogicalColumnName()))) {
/* 361 */         logicalColumnName = StringHelper.quote(logicalColumnName);
/*     */       }
/* 363 */       getMappings().addColumnBinding(logicalColumnName, getMappingColumn(), value.getTable());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static int checkReferencedColumnsType(Ejb3JoinColumn[] columns, PersistentClass referencedEntity, ExtendedMappings mappings)
/*     */   {
/* 380 */     Set<Column> idColumns = new HashSet();
/* 381 */     Iterator idColumnsIt = referencedEntity.getKey().getColumnIterator();
/* 382 */     while (idColumnsIt.hasNext()) {
/* 383 */       idColumns.add((Column)idColumnsIt.next());
/*     */     }
/*     */     
/* 386 */     boolean isFkReferencedColumnName = false;
/* 387 */     boolean noReferencedColumn = true;
/*     */     
/* 389 */     if (columns.length == 0) return 0;
/* 390 */     Object columnOwner = BinderHelper.findColumnOwner(referencedEntity, columns[0].getReferencedColumn(), mappings);
/*     */     
/*     */ 
/* 393 */     if (columnOwner == null) {
/*     */       try {
/* 395 */         throw new MappingException("Unable to find column with logical name: " + columns[0].getReferencedColumn() + " in " + referencedEntity.getTable() + " and its related " + "supertables and secondary tables");
/*     */ 
/*     */ 
/*     */       }
/*     */       catch (MappingException e)
/*     */       {
/*     */ 
/* 402 */         throw new RecoverableException(e);
/*     */       }
/*     */     }
/* 405 */     Table matchingTable = (columnOwner instanceof PersistentClass) ? ((PersistentClass)columnOwner).getTable() : ((Join)columnOwner).getTable();
/*     */     
/*     */ 
/*     */ 
/* 409 */     for (Ejb3JoinColumn ejb3Column : columns) {
/* 410 */       String logicalReferencedColumnName = ejb3Column.getReferencedColumn();
/* 411 */       if (StringHelper.isNotEmpty(logicalReferencedColumnName)) {
/* 412 */         String referencedColumnName = null;
/*     */         try {
/* 414 */           referencedColumnName = mappings.getPhysicalColumnName(logicalReferencedColumnName, matchingTable);
/*     */         }
/*     */         catch (MappingException me)
/*     */         {
/* 418 */           throw new MappingException("Unable to find column with logical name: " + logicalReferencedColumnName + " in " + matchingTable.getName());
/*     */         }
/*     */         
/*     */ 
/*     */ 
/* 423 */         noReferencedColumn = false;
/* 424 */         Column refCol = new Column(referencedColumnName);
/* 425 */         boolean contains = idColumns.contains(refCol);
/* 426 */         if (!contains) {
/* 427 */           isFkReferencedColumnName = true;
/* 428 */           break;
/*     */         }
/*     */       }
/*     */     }
/* 432 */     if (isFkReferencedColumnName) {
/* 433 */       return 2;
/*     */     }
/* 435 */     if (noReferencedColumn) {
/* 436 */       return 0;
/*     */     }
/* 438 */     if (idColumns.size() != columns.length)
/*     */     {
/* 440 */       return 2;
/*     */     }
/*     */     
/* 443 */     return 1;
/*     */   }
/*     */   
/*     */   public void overrideSqlTypeIfNecessary(Column column)
/*     */   {
/* 448 */     if (StringHelper.isEmpty(this.sqlType)) {
/* 449 */       this.sqlType = column.getSqlType();
/* 450 */       if (getMappingColumn() != null) getMappingColumn().setSqlType(this.sqlType);
/*     */     }
/*     */   }
/*     */   
/*     */   public void redefineColumnName(String columnName, String propertyName, boolean applyNamingStrategy)
/*     */   {
/* 456 */     if (StringHelper.isNotEmpty(columnName)) {
/* 457 */       getMappingColumn().setName(applyNamingStrategy ? getMappings().getNamingStrategy().columnName(columnName) : columnName);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static Ejb3JoinColumn[] buildJoinTableJoinColumns(JoinColumn[] annJoins, Map<String, Join> secondaryTables, PropertyHolder propertyHolder, String propertyName, String mappedBy, ExtendedMappings mappings)
/*     */   {
/*     */     Ejb3JoinColumn[] joinColumns;
/*     */     
/*     */ 
/*     */     Ejb3JoinColumn[] joinColumns;
/*     */     
/* 470 */     if (annJoins == null) {
/* 471 */       Ejb3JoinColumn currentJoinColumn = new Ejb3JoinColumn();
/* 472 */       currentJoinColumn.setImplicit(true);
/* 473 */       currentJoinColumn.setNullable(false);
/* 474 */       currentJoinColumn.setPropertyHolder(propertyHolder);
/* 475 */       currentJoinColumn.setJoins(secondaryTables);
/* 476 */       currentJoinColumn.setMappings(mappings);
/* 477 */       currentJoinColumn.setPropertyName(BinderHelper.getRelativePath(propertyHolder, propertyName));
/*     */       
/*     */ 
/* 480 */       currentJoinColumn.setMappedBy(mappedBy);
/* 481 */       currentJoinColumn.bind();
/*     */       
/* 483 */       joinColumns = new Ejb3JoinColumn[] { currentJoinColumn };
/*     */ 
/*     */     }
/*     */     else
/*     */     {
/*     */ 
/* 489 */       joinColumns = new Ejb3JoinColumn[annJoins.length];
/*     */       
/* 491 */       int length = annJoins.length;
/* 492 */       for (int index = 0; index < length; index++) {
/* 493 */         JoinColumn annJoin = annJoins[index];
/* 494 */         Ejb3JoinColumn currentJoinColumn = new Ejb3JoinColumn();
/* 495 */         currentJoinColumn.setImplicit(true);
/* 496 */         currentJoinColumn.setPropertyHolder(propertyHolder);
/* 497 */         currentJoinColumn.setJoins(secondaryTables);
/* 498 */         currentJoinColumn.setMappings(mappings);
/* 499 */         currentJoinColumn.setPropertyName(BinderHelper.getRelativePath(propertyHolder, propertyName));
/* 500 */         currentJoinColumn.setMappedBy(mappedBy);
/* 501 */         currentJoinColumn.setJoinAnnotation(annJoin, propertyName);
/* 502 */         currentJoinColumn.setNullable(false);
/*     */         
/* 504 */         currentJoinColumn.bind();
/* 505 */         joinColumns[index] = currentJoinColumn;
/*     */       }
/*     */     }
/* 508 */     return joinColumns;
/*     */   }
/*     */   
/*     */   public void setMappedBy(String entityName, String logicalTableName, String mappedByProperty) {
/* 512 */     this.mappedByEntityName = entityName;
/* 513 */     this.mappedByTableName = logicalTableName;
/* 514 */     this.mappedByPropertyName = mappedByProperty;
/*     */   }
/*     */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\Ejb3JoinColumn.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */