package com.netapp.myasup.jasper.util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class FilesZipManager {

	static final int BUFFER = 2048;
	private final Log LOG = LogFactory.getLog(getClass());

	public void zipFiles(String destZipFile, String outputPath) {
		LOG.info("destZipFile " + destZipFile + " outputPath " + outputPath);
		try {
			File f1 = new File(destZipFile);
			if(f1 != null){
				boolean success = f1.delete();
				if (!success) {
					System.out.println("Deletion failed.");
				} else {
					System.out.println("File deleted.");
				}
			}

			BufferedInputStream origin = null;
			FileOutputStream dest = new FileOutputStream(destZipFile);
			ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(dest));
			// out.setMethod(ZipOutputStream.DEFLATED);
			byte data[] = new byte[BUFFER];
			// get a list of files from current directory
			File f = new File(outputPath);
			String files[] = f.list();

			for (int i = 0; i < files.length; i++) {
				System.out.println("Adding: " + files[i]);
				String fileName = new StringBuilder().append(outputPath).append(File.separator).append(files[i]).toString();
				File file = new File(fileName);
				FileInputStream fi = new FileInputStream(file.getPath());
				origin = new BufferedInputStream(fi, BUFFER);
				ZipEntry entry = new ZipEntry(files[i]);
				out.putNextEntry(entry);
				int count;
				while ((count = origin.read(data, 0, BUFFER)) != -1) {
					out.write(data, 0, count);
				}
				origin.close();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public InputStream getZipFileStream(String fileName) {
		FileInputStream inputStream = null;
		try {
			inputStream = new FileInputStream(new File(fileName));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return inputStream;
	}

}
