/*    */ package org.hibernate.cfg;
/*    */ 
/*    */ import java.io.Serializable;
/*    */ import org.hibernate.AssertionFailure;
/*    */ import org.hibernate.util.StringHelper;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class EJB3NamingStrategy
/*    */   implements NamingStrategy, Serializable
/*    */ {
/* 15 */   public static final NamingStrategy INSTANCE = new EJB3NamingStrategy();
/*    */   
/*    */   public String classToTableName(String className) {
/* 18 */     return StringHelper.unqualify(className);
/*    */   }
/*    */   
/*    */   public String propertyToColumnName(String propertyName) {
/* 22 */     return StringHelper.unqualify(propertyName);
/*    */   }
/*    */   
/*    */   public String tableName(String tableName) {
/* 26 */     return tableName;
/*    */   }
/*    */   
/*    */   public String columnName(String columnName) {
/* 30 */     return columnName;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public String collectionTableName(String ownerEntity, String ownerEntityTable, String associatedEntity, String associatedEntityTable, String propertyName)
/*    */   {
/* 37 */     return tableName(ownerEntityTable + "_" + (associatedEntityTable != null ? associatedEntityTable : StringHelper.unqualify(propertyName)));
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public String joinKeyColumnName(String joinedColumn, String joinedTable)
/*    */   {
/* 48 */     return columnName(joinedColumn);
/*    */   }
/*    */   
/*    */ 
/*    */   public String foreignKeyColumnName(String propertyName, String propertyEntityName, String propertyTableName, String referencedColumnName)
/*    */   {
/* 54 */     String header = propertyName != null ? StringHelper.unqualify(propertyName) : propertyTableName;
/* 55 */     if (header == null) throw new AssertionFailure("NamingStrategy not properly filled");
/* 56 */     return columnName(header + "_" + referencedColumnName);
/*    */   }
/*    */   
/*    */   public String logicalColumnName(String columnName, String propertyName) {
/* 60 */     return StringHelper.isNotEmpty(columnName) ? columnName : StringHelper.unqualify(propertyName);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public String logicalCollectionTableName(String tableName, String ownerEntityTable, String associatedEntityTable, String propertyName)
/*    */   {
/* 67 */     if (tableName != null) {
/* 68 */       return tableName;
/*    */     }
/*    */     
/*    */ 
/* 72 */     return ownerEntityTable + "_" + (associatedEntityTable != null ? associatedEntityTable : StringHelper.unqualify(propertyName));
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public String logicalCollectionColumnName(String columnName, String propertyName, String referencedColumn)
/*    */   {
/* 82 */     return StringHelper.unqualify(propertyName) + "_" + referencedColumn;
/*    */   }
/*    */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\EJB3NamingStrategy.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */